unit Hm407def;

interface

uses windows, sysUtils, graphics, classes, printers, gauges,
     Forms, Controls, Buttons, StdCtrls, ExtCtrls, Dialogs, jmmUtil;

const
        IntSansSignif = -1;
        ACQImpossible = ' => acquisition impossible';
        NbrePointsMemoire = 2048;
        voieX = 0;
        voieCH1 = 1;
        voieCH2 = 2;
        extensionHameg = '.hm';
        MaxCalibre = 15;
        CalibreDefaut = 5;
        MaxBaseDeTemps = 28;
        TimeOutLecture = 4;
// lecture de 2048 points  9600 bauds = 2 secondes 

type
        Chaine = string[32];
        indiceVecteur = 0..NbrePointsMemoire;
        indiceVoie = voieCH1..voieCH2;
        vecteur = array[indiceVecteur] of integer;
        Tcalibre = 0..MaxCalibre; { 1mV  20 V }
        TbaseDeTemps = 0..MaxBaseDeTemps; { 50 ns  100 s }

        TvoieHameg = class
                calibre : single;
                codeCalibre : Tcalibre;
                codeVoie : char;
                Nom : chaine;
                decalage : integer;
                Active : boolean;
                Signif : String;
                valeur : vecteur;
                gauge : Tgauge;
                calibreLabel : TLabel;
                constructor create;
                function strWin(j : indiceVecteur) : String;
                function strReg(j : indiceVecteur) : String;
        end;

const
     vitesseBaud : array[0..1] of LongInt = (9600,19200);
     gamme : array[Tcalibre] of real =
                (0.001,0.002,0.005,
                 0.01,0.02,0.05,
                 0.1,0.2,0.5,
                 1,2,5,
                 10,20,50,
                 100);
     nomCalibre : array[Tcalibre] of string[4] =
                ('1m','2m','5m',
                 '10m','20m','50m',
                 '100m','200m','500m',
                 '1','2','5',
                 '10','20','50',
                 '100');
     Duree : array[TbaseDeTemps] of real =
             (50e-9,
              100e-9,200e-9,500e-9,
              1e-6,2e-6,5e-6,
              10e-6,20e-6,50e-6,
              100e-6,200e-6,500e-6,
              1e-3,2e-3,5e-3,
              10e-3,20e-3,50e-3,
              100e-3,200e-3,500e-3,
              1,2,5,
              10,20,50,
              100);
    NomBaseDeTemps : array[TbaseDeTemps] of string[4] =
             ('50n',
              '100n','200n','500n',
              '1','2','5',
              '10','20','50',
              '100','200','500',
              '1m','2m','5m',
              '10m','20m','50m',
              '100m','200m','500m',
              '1','2','5',
              '10','20','50',
              '100');


Var deltat : single;
    codeBaseDetemps : TbaseDeTemps;

IMPLEMENTATION

function TvoieHameg.strWin(j : indiceVecteur) : String;
begin
    result := FloatToStrWin((valeur[j]-decalage)*calibre/25.0)
end;

function TvoieHameg.strReg(j : indiceVecteur) : String;
begin
    result := FloatToStrReg((valeur[j]-decalage)*calibre/25.0)
end;

constructor TvoieHameg.Create;
begin
        inherited create;
        Signif := 'tension';
        calibre := 1.0;
        active := true;
        Nom :='V';
end;{--- TvoieHameg.Create ---}

end. 

