unit Jmmutil;

interface

uses
   SysUtils, Windows, Messages, Classes, Dialogs, Forms,
   StdCtrls, Consts, ShlObj, Math,
   oomisc, awUser;

const
   RadianVersDegre = 57.29577951308232090;
   SymbReg: char = '';
   SymbReg2: char = '&';
   Tabulation = #9;
   extensionHP = '.osc';

        alphaR =  AnsiChar(128);
        betaR = AnsiChar(129);
        chiR = AnsiChar(130);
        deltaR = AnsiChar(131); deltaMajR = AnsiChar(150);
        epsilonR = AnsiChar(132);
        phiR = AnsiChar(133); phiMajR = AnsiChar(151);
        gammaR = AnsiChar(134); gammaMajR = AnsiChar(152);
        etaR = AnsiChar(135);
        lambdaR = AnsiChar(136); lambdaMajR = AnsiChar(153);
        nuR = AnsiChar(138);
        piR = AnsiChar(139);piMajR = AnsiChar(154);
        thetaR = AnsiChar(140);thetaMajR = AnsiChar(155);
        rhoR = AnsiChar(141);
        sigmaR = AnsiChar(142);sigmaMajR = AnsiChar(156);
        tauR = AnsiChar(143);
        omegaR = AnsiChar(144);omegaMajR = AnsiChar(157);
        xiR = AnsiChar(147);xiMajR = AnsiChar(158);
        psiR = AnsiChar(148);psiMajR = AnsiChar(159);
        zetaR = AnsiChar(149);
        muR = AnsiChar(181);

        alpha=WideChar($03B1);alphaMaj=WideChar($0391);
        beta=WideChar($03B2);betaMaj=WideChar($0392);
        gamma=WideChar($03B3);gammaMaj=WideChar($0393);
        delta=WideChar($03B4);deltaMaj = WideChar($0394);
        chi=WideChar($03C7);chiMaj=WideChar($03A7);
        epsilon=WideChar($03B5);epsilonMaj=WideChar($0395);
        upsilon=WideChar($03C5);upsilonMaj=WideChar($03A5);
        iota=WideChar($03B9);iotaMaj=WideChar($0399);
        phi=WideChar($03C6);phiMaj=WideChar($03A6);
        eta=WideChar($03B7);etaMaj=WideChar($0397);
        lambdaMaj=WideChar($039B);lambda=WideChar($03BB);
        nu=WideChar($03BD);nuMaj=WideChar($039D);
        xiMaj=WideChar($039E);xi=WideChar($03BE);
        piMin=WideChar($03C0);piMaj=WideChar($03A0);
        thetaMaj=WideChar($0398);theta=WideChar($03B8);
        rho=WideChar($03C1);rhomaj=WideChar($03A1);
        sigma=WideChar($03C3);sigmaMaj=WideChar($03A3);
        tau=WideChar($03C4); tauMaj=WideChar($03A4);
        omega=WideChar($03C9);omegaMaj=WideChar($03A9);
        psi=WideChar($03C8);psiMaj=WideChar($03A8);
        zeta=WideChar($03B6);zetaMaj=WideChar($0396);
        mu=WideChar($03BC);muMaj=WideChar($039C);
        kappa=WideChar($03BA);kappaMaj=WideChar($039A);
        omicron=WideChar($03Bf);omicronMaj=WideChar($039F);

        supegal=WideChar($2265);
        infegal=WideChar($2264);

type
   ChaineAzt = array[0..255] of ansiChar;
   Tlecture  = (LectNone, LectDiese, LectNcarac, LectNByte, LectData, LectSkip);
   CoefUnite = (zero, yocto, zepto, atto, femto, pico, nano, micro, milli,
      nulle, kilo, mega, giga, tera, peta, exa, zetta, yotta, infini);

const
   Majuscule: TsyscharSet = ['A'..'Z'];
   Minuscule: TsyscharSet = ['a'..'z'];
   Grecque: TsyscharSet = [alpha, beta, gamma, gammaMaj, delta, deltaMaj, chi,
      epsilon, phi, phiMaj, eta, psi, psiMaj, lambda, lambdaMaj, mu, nu,
      piMin, piMaj, theta, thetaMaj, rho, sigma, sigmaMaj, tau, omega, omegaMaj,
      xi, xiMaj, zeta];
   Chiffre: TsyscharSet = ['0'..'9'];
   ChiffreEtc: TsyscharSet = ['0'..'9', '+', '-', 'e', 'E', '.'];
   ChiffreEtcHameg: TsyscharSet = ['0'..'9', '+', '-', 'e', 'E', '.', 'm', 'u', 'k', ''];
   ChiffreWin: TsyscharSet = ['0'..'9', '+', '-', 'e', 'E', '.', ','];
   crTab      = char(vk_tab);
   crSupprArr = char(vk_back);
   crHaut     = char(vk_up);
   crBas      = char(vk_down);
   crGauche   = char(vk_left);
   crDroite   = char(vk_right);
   crHome     = char(vk_home);
   crEnd      = char(vk_end);
   crCR       = #13;   // $0D
   crLF       = #10;   // $0A
   crESC      = #27;
   crXon      = #17;
   crXoff     = #19;
   symboleUnite: array[coefUnite] of char =
      ('0', 'y', 'z', 'a', 'f', 'p', 'n', '', 'm', ' ', 'k', 'M', 'G',
      'T', 'P', 'E', 'Z', 'Y', '');
   valUnite: array[coefUnite] of real =
      (1E-27, 1E-24, 1E-21, 1E-18, 1E-15, 1E-12, 1E-9, 1E-6, 1E-3, 1,
      1E+3, 1E+6, 1E+9, 1E+12, 1E+15, 1E+18, 1E+21, 1E+24, 1E+27);
   caracUnite: TsyscharSet =
      ['A'..'Z', 'a'..'z', OmegaMaj, '1'..'3', '-', '.', '/', ''];
   puissanceUnite: array[coefunite] of shortint =
      (-27, -24, -21, -18, -15, -12, -9, -6, -3,
      0, +3, +6, +9, +12, +15, +18, +21, +24, +27);
   expUnite: array[coefUnite] of string =
      ('E-27', 'E-24', 'E-21', 'E-18', 'E-15', 'E-12', 'E-9', 'E-6', 'E-3',
      '', 'E+3', 'E+6', 'E+9', 'E+12', 'E+15', 'E+18', 'E+21', 'E+24', 'E+27');
   separateur: TsysCharSet   = [' ', crTab, ','];
   caracPrefixe: TsyscharSet =
      ['y', 'z', 'a', 'f', 'p', 'n', '', 'm', 'k', 'M', 'G', 'T', 'P', 'E'];

function Pad(S: string; Len: byte): string;
procedure VerifKeyNum(var key: char);
function ConvertitChaine(nombre: string; var valeur: double): boolean;
function FormatCourt(nombre: double; NomUnite: string): string;
function FloatToStrPoint(valeur: double): string;
function StrToFloatWin(nombre: String): double;
function DureeEcoulee(InstantDebut: TdateTime): double;
function EncodeDuree(duree: longint): TdateTime;
function IntMaths(x: extended): extended;
function OK(texte: string): boolean;
procedure Erreur(texte: string);
function IsPortAvailable(ComNum: cardinal): boolean;
function Atan2(im, re: double): double;
function valeur125(valeur: double): double;
function unTour : double;

Function FloatToStrWin(valeur : double) : string;
Function FloatToStrReg(valeur : double) : string;
Function UnicodeVersRW3(s : string) : ansiString;

var
   enDegre: boolean = True;
   appDataDir, MesDocsDir,nomFichierConfig: string;

implementation

procedure ConvertitPrefixe(var nombre: string);
var
   u: coefUnite;
   c: char;
   i: integer;
begin
   i := 1;
   while i <= length(nombre) do begin
      if nombre[i] = ' ' then
         Delete(nombre, i, 1)
      else
         Inc(i);
   end;
   c := nombre[length(nombre)];
   if charinset(c,caracPrefixe) then begin
      u := zero;
      repeat
         Inc(u)
      until (c = symboleUnite[u]);
      Delete(nombre, length(nombre), 1);
      nombre := nombre + expUnite[u];
   end;
end;

function StrToFloatWin(nombre: string): double;
var
   posSeparator: integer;
begin
   case decimalSeparator of
        '.' : posSeparator := pos(',', nombre);
        ',' : posSeparator := pos('.', nombre);
        else posSeparator := 0;
   end;
   if posSeparator > 0 then
      Nombre[posSeparator] := decimalSeparator;
   convertitPrefixe(nombre);
   try
      StrToFloatWin := strToFloat(nombre);
   except
      StrToFloatWin := Nan
   end;
end;

function FloatToStrPoint(valeur: double): string;
var
   nombre: string;
   posSeparator: byte;
begin
   nombre := FloatToStrF(valeur, ffGeneral, 7, 1);
   if decimalSeparator <> '.' then begin
      posSeparator := pos(decimalSeparator, nombre);
      if posSeparator > 0 then
         Nombre[posSeparator] := '.';
   end;
   Result := nombre;
end;

function ConvertitChaine(nombre: string; var valeur: double): boolean;
begin
   if (upcase(nombre[1]) = 'E') then
      nombre := '1' + nombre
   else if nombre[1] = '.' then
      nombre := '0' + nombre;
   valeur := StrToFloatWin(nombre);
   convertitChaine := not isNan(valeur);
end;

function FormatCourt(Nombre: double; NomUnite: string): string;
var
   unite:  coefUnite;
   Negatif: boolean;
   tampon: string;
begin
   if isnan(nombre) then
      FormatCourt := ' '
   else begin
      negatif := nombre < 0;
      nombre := abs(nombre);
      unite := nulle;
      while (nombre >= 999) and (unite < infini) do begin
         nombre := nombre / 1000;
         Inc(unite);
      end; { nombre<1000 ou infini }
      while (nombre < 0.999) and (unite > zero) do begin
         nombre := nombre * 1000;
         Dec(unite);
      end; { nombre>=1 ou zero }
      if unite in [infini, zero] then
         tampon := '0 '
      else begin
         tampon := FloatToStrF(nombre, ffGeneral, 4, 0);
         if negatif then
            tampon := '-' + tampon;
         tampon := tampon + ' ';
         if unite <> nulle then
            tampon := tampon + symboleUnite[unite];
      end;
      FormatCourt := tampon + NomUnite;
   end;
end;

function ToucheValidation(key: word): boolean;
begin
   ToucheValidation := key in [vk_tab, vk_left, vk_right, vk_down, vk_up, vk_return];
end;

procedure VerifKeyNum(var key: char);
begin
   if not charinset(key,ChiffreEtc + [crSupprArr]) then
      key := #0;
end;

function DureeEcoulee(InstantDebut: TdateTime): double;
var
   h, m, s, ms: word;
begin
   decodeTime(time - instantDebut, h, m, s, ms);
   DureeEcoulee := h * 3600.0 + m * 60.0 + s * 1.0 + ms * 0.001;
end;

function Pad(S: string; Len: byte): string;
// Return a string right-padded to length len with ' '
var i,slen : integer;
begin
   Slen := length(S);
   if SLen >= Len then begin
      result := copy(S, 1, Len);
      exit;
   end;
   result := S;
   for i := slen+1 to len do result := result + ' ';
end;

function EncodeDuree(duree: longint): TdateTime;
var
   h, m, s, ms: word;
begin
   h  := duree div 3600;
   duree := duree - h * 3600;
   m  := duree div 60;
   duree := duree - m * 60;
   s  := duree;
   ms := 0;
   EncodeDuree := EncodeTime(h, m, s, ms);
end;

function IntMaths(x: extended): extended;
   { "vraie" partie entire }
var
   zut: extended;
begin
   Zut := int(x);
   if (x >= 0) or (zut = x) then
      intMaths := zut
   else
      intMaths := zut - 1;
end;

function OK(texte: string): boolean;
begin
   OK := MessageDlg(texte, mtConfirmation, [mbYes, mbNo], 0) = idYes;
end;

procedure Erreur(texte: string);
begin
   MessageDlg(texte, mtInformation, [mbOK], 0);
end;

Function UnicodeVersRW3(s : string) : ansiString;
var i : integer;
    carac : char;
    caracR : ansiChar;
begin
     result := '';
     for i := 1 to length(s) do begin
         carac := s[i];
         if charinset(carac,grecque)
            then case carac of
                      alpha : caracR := alphaR;
                      beta : caracR := betaR;
                      gamma: caracR := gammaR;
                      gammaMaj: caracR := gammaMajR;
                      delta: caracR := deltaR;
                      deltaMaj: caracR := deltaMajR;
                      epsilon: caracR := epsilonR;
                      zeta: caracR := zetaR;
                      eta: caracR := etaR;
                      kappa: caracR := 'k';
                      lambda: caracR := lambdaR;
                      lambdaMaj: caracR := lambdaMajR;
                      mu: caracR := '';
                      nu: caracR := nuR;
                      xi: caracR := xiR;
                      xiMaj: caracR := xiMajR;
                      pimin: caracR := piR;
                      piMaj: caracR := piMajR;
                      rho: caracR := rhoR;
                      sigma: caracR := sigmaR;
                      sigmaMaj: caracR := sigmaMajR;
                      tau: caracR := tauR;
                      theta: caracR := thetaR;
                      thetaMaj: caracR := thetaMajR;
                      phi: caracR := phiR;
                      phiMaj: caracR := phiMajR;
                      chi: caracR := chiR;
                      psi: caracR := psiR;
                      psiMaj: caracR := psiMajR;
                      omega: caracR := omegaR;
                      omegaMaj: caracR := omegaMajR;
                      else caracR := '?';
                 end
            else caracR := ansiChar(carac);
            result := result+caracR;
     end;
end;

function IsPortAvailable(ComNum: cardinal): boolean;
var
  ComName: string;
  Res: Integer;
begin
  ComName := Format('\\.\COM%d', [ComNum]);
  try
  if ComNum = 0
    then Result := False
    else begin
// SZ: optimize this one - otherwise bluetooth devices may request confirmation
        Res := CreateFile(PChar(ComName), GENERIC_READ or GENERIC_WRITE, 0, nil,
          OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL or FILE_FLAG_OVERLAPPED, 0);
        Result := (Res >= 0) or (GetLastError = DWORD(ecAccessDenied));
        if Res >= 0 then CloseHandle(Res)
  end;
  except
     result := false;
  end;
end;

function valeur125(valeur: double): double;
var
   mantisse, exposant, coeff: double;
begin
   exposant := log10(valeur);
   coeff := Int(exposant);
   if (exposant < 0) and (coeff <> exposant) then
      coeff := coeff - 1;
   coeff := power(10,coeff);
   mantisse := Int(valeur / coeff);
   if mantisse > 2 then
      if mantisse < 6 then
         mantisse := 5
      else
         mantisse := 10;
   Result := mantisse * coeff;
end;

function Atan2(im, re: double): double;
   { z = re + j*im }
begin
   try
      Result := arcTan(im / re);
      if re < 0 then
         if im < 0 then
            Result := Result - pi
         else
            Result := Result + pi;
   except
      on EZeroDivide do
      begin
         if im < 0 then
            Result := -pi / 2
         else
            Result := pi / 2;
      end;
   end;
   if EnDegre then
      Result := Result * RadianVersDegre;
end;

Function FloatToStrWin(valeur : double) : string;
begin
   result := FloatToStrF(valeur,ffGeneral,6,2)
end;

Function FloatToStrReg(valeur : double) : string;
var posSeparator : integer;
begin
   result := FloatToStrF(valeur,ffGeneral,7,2);
   if decimalSeparator=',' then begin
      posSeparator := pos(',',result);
      if posSeparator>0 then result[posSeparator] := '.';
   end;
end;

function AddBackSlash(aPath: string): string;
begin
   Result := EmptyStr;
   if (aPath <> '') and (aPath[Length(aPath)] <> '\') then
      Result := aPath + '\';
end;

// permet de retrouver un repertoire d'aprs sa valeur CSIDL
function GetFolder(CSIDLValue: integer): string;
var
   IdList: PITEMIDLIST;
   Folder: array[0..MAX_PATH] of char;
begin
   if not Failed(SHGetSpecialFolderLocation(0, CSIDLValue, IdList)) then
   begin
      SHGetPathFromIDList(IdList, Folder);
      Result := AddBackSlash(Folder);
   end;
end;

function unTour : double;
begin
   if enDegre
     then result := 360
     else result := 2*pi
end;

initialization
   mesDocsDir := GetFolder(CSIDL_Personal)+ 'Regressi';
   if not DirectoryExists(MesDocsDir) then
      createDir(MesDocsDir);
   MesDocsDir :=  AddBackSlash(mesDocsDir);
   appDataDir := GetFolder(CSIDL_AppData)+ 'Regressi';
   if not DirectoryExists(appDataDir) then
       createDir(appDataDir);
   appDataDir := AddBackSlash(appDataDir);
   nomFichierConfig := changeFileExt(application.ExeName,'.ini');
end.

