unit Hm407dde;
{ Regressi Client pour recevoir les donnes de l'acquisition }

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DdeMan, ExtCtrls, FileCtrl, registry,
  Hm407m, hm407Def, jmmUtil, hmconst, ComCtrls, clipbrd, shellApi, math;

type
 Tenvoi = (eAdd,eLoad,ePlus,eAddCol,eFocus);
  TFormDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    procedure FormCreate(Sender: TObject);
    procedure ExecuteMacro(Sender: TObject; Msg: TStrings);
  private
    procedure AjouteConst(var donnees : tstringList);
    function GetFnName(const BufStr: String): String;
    function GetArgs(const BufStr: String): String;
  public
      procedure Execute(Ordre : Tenvoi);
      procedure EnvoieDonnees(DDE : boolean);
  end;

var
  FormDDE: TFormDDE;

implementation

{$R *.DFM}

procedure TFormDDE.Execute(Ordre : Tenvoi);

procedure Lance;
begin
    case ordre of
         eAdd : if not ClientDDE.ExecuteMacro('CLIP|ADD', false) then
            ShowMessage('Transfert non excut');
         eLoad : if not ClientDDE.ExecuteMacro('CLIP|LOAD', false) then
            ShowMessage('Transfert non excut');
         ePlus : if not ClientDDE.ExecuteMacro('CLIP|PLUS', false) then
            ShowMessage('Transfert non excut');
         eAddCol : if not ClientDDE.ExecuteMacro('CLIP|ADDCOL', false) then
            ShowMessage('Transfert non excut');
    end;
    ClientDDE.CloseLink;
end;

begin
     ClientDDE.SetLink('Regressi','ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
        then lance
        else begin
           sleep(1000);
           if ClientDDE.OpenLink
               then lance
               else ShowMessage('Impossible de lancer Regressi');
        end;
end;

procedure TFormDDE.AjouteConst(var donnees : tstringList);
var valeurConst : extended;
begin with ConstanteDlg do begin
     if (NomConstEdit.text='') then exit;
     ValeurConst := StrToFloatWin(ValeurConstEdit.text);
     if isNan(valeurConst) then exit;
     Donnees.Add('');
     Donnees.Add(NomConstEdit.text);
     Donnees.Add(UniteConstEdit.text);
     Donnees.Add(FloatToStrWin(valeurConst));
end end;

procedure TFormDDE.EnvoieDonnees(DDE : boolean);
var donnees : TStringList;
    NbreVoie : integer;
    Pas : integer;

Procedure AjouteOptionsGr;
var v : indiceVoie;
begin
     donnees.Add(symbReg2+intToStr(NbreVoie)+' NOMX');
     for v := voieCH1 to voieCH2 do if HamegMain.voie[v].active then
         donnees.Add('t');
     donnees.Add(symbReg2+intToStr(NbreVoie)+' NOMY');
     for v := voieCH1 to voieCH2 do if HamegMain.voie[v].active then
         donnees.Add(HamegMain.voie[v].nom);
     donnees.Add(symbReg2+intToStr(NbreVoie)+' LIGNE');
     for v := voieCH1 to voieCH2 do if HamegMain.voie[v].active then
         donnees.Add('1')
end;

var i : indiceVecteur;
    v : indiceVoie;
    ligne : String;
begin
     NbreVoie := 0;
     Pas := HamegMain.pasSE.Value;
     Donnees := tstringList.create;
     Donnees.Add(Application.ExeName);
     if ConstanteDlg.NewPageCB.itemIndex=0
        then Donnees.Add('Acquisition avec oscillo HAMEG')
        else Donnees.Add('');
     Donnees.Add(ConstanteDlg.EditComm.text);
     ligne := 't';
     for v := voieCH1 to voieCH2 do if HamegMain.voie[v].active then begin
           ligne := ligne+crTab+HamegMain.voie[v].nom;
           inc(NbreVoie);
     end;
     Donnees.Add(ligne);
     ligne := 's';
     for v := voieCH1 to voieCH2 do if HamegMain.voie[v].active then
         ligne := ligne+crTab+'V';
     Donnees.Add(ligne);
     ligne := 'temps '+nomBaseDeTemps[codeBaseDeTemps]+'s/div';
     for v := voieCH1 to voieCH2 do if HamegMain.voie[v].active then
         ligne := ligne+crTab+HamegMain.voie[v].signif+' '+
                 nomCalibre[HamegMain.voie[v].codeCalibre]+'V/div';
     Donnees.Add(ligne);
     for i := 0 to pred(NbrePointsMemoire) do if (i mod pas)=0 then begin
         ligne := FloatToStrReg(i*deltat);
         for v := voieCH1 to voieCH2 do if HamegMain.voie[v].active then
             ligne := ligne+crTab+HamegMain.voie[v].strReg(i);
         Donnees.Add(ligne);
     end;
     AjouteConst(donnees);
     if DDE and (ConstanteDlg.NewPageCB.itemIndex=0) then AjouteOptionsGr;     
     ClipBoard.asText := Donnees.text;
     if DDE then begin
        if ConstanteDlg.NewPageCB.itemIndex=0
           then Execute(eLOAD)
           else Execute(eADD);
        ConstanteDlg.NewPageCB.itemIndex := 1
     end;
     donnees.free;
end;

procedure TFormDDE.FormCreate(Sender: TObject);
var Ini : TregIniFile;
    RegressiName : String;
begin
    Ini := TRegIniFile.create('Software');
    RegressiName := Ini.ReadString('Regressi','Path','');
    Ini.Free;
    Ini := TregIniFile.create('Software\Regressi');
    RegressiName := Ini.ReadString('Regressi','Path',RegressiName);
    Ini.Free;
    ClientDDE.ServiceApplication := RegressiName;
end;

procedure TFormDDE.ExecuteMacro(Sender: TObject; Msg: TStrings);
var Fonction,NomFichier : string;
begin
     if (Msg.Count = 1) then begin
       try
       NomFichier := GetArgs(Msg[0]);
       Fonction := GetFnName(Msg[0]);
       if CompareText('CONFIG|LOAD',Fonction) = 0 then exit;
       if CompareText('CONFIG|SAVE',Fonction) = 0 then exit;
       if CompareText('FOCUS',Fonction) = 0 then begin
           ConstanteDlg.NewPageCB.itemIndex := 0;
           HamegMain.setFocus;
           exit;
       end;
       if CompareText('GETDATA',Fonction) = 0 then begin
           ConstanteDlg.NewPageCB.itemIndex := 1;
           postMessage(HamegMain.Handle,WM_ACQ_REG,0,0);
           exit;
       end;
       MessageDlg('Fonction inconnue : ' + Msg[0], mtError, [mbOK], 0);
       except
            MessageDlg('Syntaxe Macro DDE : Fonction(Paramtre)', mtError, [mbOK], 0);
       end;
     end
     else MessageDlg('Un message  la fois SVP', mtError, [mbOk], 0);
end;

function TFormDDE.GetArgs(const BufStr: String): String;
var ArgStart, ArgEnd : integer;
begin
  { recherche parenthses ouvrante et fermante : fonction(argument) }
  ArgStart := Pos('(', BufStr);
  ArgEnd := Pos(')', BufStr);
  if (ArgStart >= ArgEnd)
     then result := ''
     else result := Copy(BufStr, Succ(ArgStart), ArgEnd - Succ(ArgStart));
end;

function TFormDDE.GetFnName(const BufStr: String): String;
var OpenBracketPos : integer;
begin
  OpenBracketPos := Pos('(', BufStr);
  if (OpenBracketPos <= 0)
     then result := BufStr
     else result := Copy(BufStr, 1, Pred(OpenBracketPos));
end;

end.
