unit Hm407m;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ADport, sysUtils, Messages,
  clipBrd, spin, adexcept, inifiles,
  jmmUtil, hm407def, Gauges, hmconst, hm407com, OoMisc, XPMan;

const
     WM_Acq_Reg = WM_USER + 0;

type
  THamegMain = class(TForm)
    SaveDialogData: TSaveDialog;
    VoieSerie: TApdComPort;
    BoutonsPanel: TPanel;
    FileSaveBtn: TSpeedButton;
    ClipSaveBtn: TSpeedButton;
    RegSaveBtn: TSpeedButton;
    EnregistreBtn: TSpeedButton;
    SetBtn: TSpeedButton;
    GroupBoxCH1: TGroupBox;
    Nom2Edit: TEdit;
    Label1: TLabel;
    CloseBtn: TSpeedButton;
    AideBtn: TSpeedButton;
    Gauge2: TGauge;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Gauge1: TGauge;
    Nom1Edit: TEdit;
    CalibreLabel1: TLabel;
    CalibreLabel2: TLabel;
    SignifEdit1: TEdit;
    SignifEdit2: TEdit;
    Label2: TLabel;
    Label4: TLabel;
    GroupBox1: TGroupBox;
    BaseDeTempsLabel: TLabel;
    XPManifest1: TXPManifest;
    ErreurLabel: TLabel;
    PasSE: TSpinEdit;
    Label5: TLabel;
    procedure ShowHint(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure SaveItemClick(Sender: TObject);
    procedure AboutItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RegressiItemClick(Sender: TObject);
    procedure RegSaveBtnClick(Sender: TObject);
    procedure ClipSaveBtnClick(Sender: TObject);
    procedure SetOscilloClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure VoieSerieTriggerAvail(CP: TObject; Count: Word);
    procedure VoieSerieTriggerReponse(CP: TObject; Count: Word);
    procedure NomEditChange(Sender: TObject);
    procedure RegNewFileItemClick(Sender: TObject);
    procedure SignifEditChange(Sender: TObject);
  private
    IdentiteScope,VersionScope,chaineBin : ansiString;
    codeVitesse : integer;
    NbreCourant,CaracCourant : integer;
    AcqFaite,Sauvegarde,OscilloBranche : boolean;
    AppelRegressi,TestEnCours : boolean;
    voieCourante : byte;
    ListeCode : TstringList;
    RegHM407 : string;
    grecActif : boolean;
    Procedure SetBoutonAcq;
    Procedure VerifOscillo;
    Function GetStringCRLF(const Commande : ansiString) : ansiString;
    Function GetStringCount(const Commande : ansiString;count : integer) : ansiString;
    Procedure RemoteON;
    Procedure RemoteOFF;
    Procedure AfficheErreur(R : string);
  public
      voie : array[indiceVoie] of TvoieHameg;
      procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
  protected
     procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo); message wm_GetMinMaxInfo;
     procedure WMAcqReg(var Msg : TMessage); message WM_Acq_Reg;
  end;

var
  HamegMain: THamegMain;

implementation

uses hm407a, hm407DDE;

{$R *.DFM}

procedure THamegMain.AppMessage(var Msg: TMsg; var Handled: Boolean);
const
         GrecMaj : array[0..25] of char =
  (alphaMaj,BetaMaj,chiMaj,deltaMaj,EpsilonMaj,phiMaj,gammaMaj,etaMaj,iotaMaj,
   psiMaj,kappaMaj,lambdaMaj,MuMaj,NuMaj,omicronMaj,piMaj,thetaMaj,RhoMaj,
   sigmaMaj,tauMaj,upsilonMaj,'V',omegaMaj,xiMaj,'Y',zetaMaj);

        GrecMin : array[0..25] of char =
  (alpha,beta,chi,delta,epsilon,phi,gamma,eta,iota,psi,kappa,lambda,
   mu,nu,omicron,piMin,theta,rho,sigma,tau,upsilon,'v',omega,xi,'y',zeta);

var codeCarac : integer;
begin with Msg do
     case Message of
          wm_char : if (Wparam=7) and (GetKeyState(vk_control)<0)  // Ctrl+G
            then GrecActif := true
            else if grecActif then begin
                 CodeCarac := Wparam-ord('A');
                 if (CodeCarac<26) and (codeCarac>=0)
                    then Wparam := ord(GrecMaj[CodeCarac])
                    else begin
                        CodeCarac := Wparam-ord('a');
                        if (CodeCarac<26) and (codeCarac>=0) then Wparam := ord(GrecMin[codeCarac]);
                    end;
                 grecActif := false;
            end;
    end;
end;

procedure THamegMain.ShowHint(Sender: TObject);
begin
    if Application.Hint=''
       then Caption := IdentiteScope+' '+VersionScope
       else Caption := Application.Hint
end;

procedure THamegMain.ExitItemClick(Sender: TObject);
begin
  if AcqFaite and not sauvegarde and
     (MessageDlg('Sauvegarde',mtConfirmation,[mbYes,mbNo],0)=mrYes)
     then SaveItemClick(sender);
  Close;
end;

procedure THamegMain.SaveItemClick(Sender: TObject);
var fichier : textFile;
    formatRW3 : boolean;

Procedure EcritPage;
var j : indiceVecteur;
    v : indiceVoie;
begin
   writeln(fichier,symbReg,1,' PAGE COMMENT');
   writeln(fichier,'');
   writeln(fichier,symbReg2,NbrePointsMemoire,' VALEUR VAR');
   for j := 0 to pred(NbrePointsMemoire) do begin
       write(fichier,FloatToStrReg(j*deltat));
       for v := voieCH1 to voieCH2 do if voie[v].active then
             write(fichier,crTab,voie[v].strReg(j));
       writeln(fichier);
   end;
end; {ecritPage}

Procedure EcritData;
var j : indiceVecteur;
    v : indiceVoie;
begin
   for j := 0 to pred(NbrePointsMemoire) do begin
       write(fichier,FloatToStrWin(j*deltat));
       for v := voieCH1 to voieCH2 do if voie[v].active then
           write(fichier,crTab,voie[v].strWin(j));
       writeln(fichier);
   end;
end; {ecritData}

Procedure ecritEnTete;
var v : indiceVoie;
    Nbre : byte;
begin if formatRW3 then begin
   Nbre := 1;
   for v := voieCH1 to voieCH2 do if voie[v].active then inc(Nbre);
   writeln(fichier,'EVARISTE REGRESSI WINDOWS 1.0');
   writeln(fichier,symbReg,IntToStr(Nbre)+' NOM VAR');
   writeln(fichier,'t');
   for v := voieCH1 to voieCH2 do if voie[v].active then
      writeln(fichier,voie[v].nom);
   writeln(fichier,symbReg,IntToStr(Nbre)+' UNITE VAR');
   writeln(fichier,'s');
   for v := voieCH1 to voieCH2 do if voie[v].active then
      writeln(fichier,'V');
   writeln(fichier,symbReg,IntToStr(Nbre)+' SIGNIF VAR');
   writeln(fichier,'temps');
   for v := voieCH1 to voieCH2 do if voie[v].active then
      writeln(fichier,voie[v].signif);
   writeln(fichier,symbReg,'1 ACQUISITION');
   writeln(fichier,Application.ExeName)
end
else begin
   writeln(fichier,'Hameg');
   write(fichier,'t');
   for v := voieCH1 to voieCH2 do if voie[v].active then
      write(fichier,crTab,voie[v].nom);
   writeln(fichier);
   write(fichier,'s');
   for v := voieCH1 to voieCH2 do if voie[v].active then
       write(fichier,crTab,'V');
   writeln(fichier);
   write(fichier,'temps');
   for v := voieCH1 to voieCH2 do if voie[v].active then
       write(fichier,crTab,voie[v].signif);
   writeln(fichier);
end
end; { ecritEnTete }

begin
    if SaveDialogData.Execute then begin
       FormatRW3 := ExtractFileExt(SaveDialogData.FileName)='.RW3';
       AssignFile(fichier,SaveDialogData.FileName);
       Rewrite(fichier);
       ecritEnTete;
       if formatRW3 then ecritPage else ecritData;
       CloseFile(fichier);
       sauvegarde := true;
    end;
end;

procedure THamegMain.AboutItemClick(Sender: TObject);
begin
    AboutBox.ShowModal
end;

procedure THamegMain.FormCreate(Sender: TObject);
var INI : Tinifile;
    i,Nombre : integer;
    code : String;
begin
  Application.OnHint := ShowHint;
  Application.OnMessage := AppMessage;
  RegHM407 := appDataDir+'hm407.ini';

  voie[voieCH1] := TvoieHameg.create;
  voie[voieCH1].nom := 'Ve';
  voie[voieCH1].codeVoie := '1';
  voie[voieCH1].gauge := gauge1;
  voie[voieCH1].calibreLabel := calibreLabel1;

  voie[voieCH2] := TvoieHameg.create;
  voie[voieCH2].nom := 'Vs';
  voie[voieCH2].codeVoie := '2';
  voie[voieCH2].gauge := gauge2;
  voie[voieCH2].calibreLabel := calibreLabel2;

  OscilloBranche := false;
  AppelRegressi := false;
  NbreCourant := 0;
  caracCourant := 1;
  Gauge1.MaxValue := NbrePointsMemoire;
  Gauge2.MaxValue := NbrePointsMemoire;
  Ini := TIniFile.Create(RegHM407);
  voieSerie.ComNumber := Ini.ReadInteger('COM','NUM',1);
  codeVitesse := Ini.readInteger('COM','Vitesse',0);
  voieSerie.baud := VitesseBaud[codeVitesse];
  voieCourante := 0;

  ListeCode := TstringList.create;
  ListeCode.sorted := true;
  ListeCode.Duplicates := dupIgnore;
  ListeCode.Add('305-2');
  ListeCode.Add('407');
  ListeCode.Add('404');
  ListeCode.Add('507');
  Nombre := Ini.readInteger('Code','Count',0);
  for i := 1 to Nombre do begin
      code := Ini.readString('Code',intToStr(i),'');
      if code<>'' then ListeCode.Add(code);
  end;
  Ini.free;
end;

procedure THamegMain.EnregistreBtnClick(Sender: TObject);
var HamegOK : boolean;

Procedure ChercheBaseDeTemps;
var reponse : ansiString;
    codeB : byte;
    codeW : word;
begin
     BaseDeTempsLabel.caption := '???';
     reponse := GetStringCount('TBA?',5);
     codeB := ord(reponse[5]);
     if (codeB and $20)=1 then begin
        showMessage('Mode analogique'+AcqImpossible);
        BaseDeTempsLabel.caption := 'Analogique !';
        HamegOK := false;
        exit;
     end;
     codeBaseDeTemps := codeB and $1F;
     deltat := duree[codeBaseDeTemps]/200.0;
     { 2000 points / 10 divisions }
     BaseDeTempsLabel.caption := nomBaseDeTemps[codeBaseDeTemps]+'s/div';
     reponse := GetStringCount('TBAVAR?',9);
     codeW := ord(reponse[8])+ord(reponse[9])*256;
     if codeW<>0 then showMessage('Attention : base de temps non calibre');
end;

Procedure ChercheCalibre(v : indiceVoie);
var codeW : word;
    reponse : String;
    codeB : byte;
begin with voie[v] do begin
     Gauge.progress := 0;
     calibreLabel.caption := '???';
     Application.processMessages;
     reponse := GetStringCount('CH'+codeVoie+'?',5);
     codeB := ord(reponse[5]);
     voie[v].active := (codeB and 16)<>0;
     codeCalibre := codeB and 15;
     calibre := gamme[codeCalibre];
     if voie[v].active
        then calibreLabel.caption := nomCalibre[codeCalibre]+'V/div'
        else calibreLabel.caption := 'OFF';
     if not voie[v].active then exit;
     reponse := GetStringCount('Y'+codeVoie+'POS?',8);
     codeW := ord(reponse[7])+ord(reponse[8])*256; { 1000 bit / div }
     if codeW<32768
        then decalage := codeW
        else decalage := codeW-65535;
     decalage := 128+decalage div 40;
        { par rapport au centre = 128 , 40=1000/25
          dcalage 1000 points / div
          data 25 points / div}
     reponse := GetStringCount('CH'+codeVoie+'VAR?',8);
     codeB := ord(reponse[8]);
     if codeB<>255 then
        showMessage('Attention : CH'+codeVoie+' non calibre');
     Application.processMessages;
end end;

var InstantDebut : TdateTime;
    v : indiceVoie;
begin
     if AcqFaite and
        not sauvegarde and
        not OK('Perte des donnes courantes') then exit;
     AcqFaite := false;
     Sauvegarde := false;
     HamegOK := true;
     remoteOn;
     chercheBaseDeTemps;
     Application.processMessages;
     if HamegOK then chercheCalibre(voieCH1);
     if HamegOK then chercheCalibre(voieCH2);
     if not HamegOK then begin
        remoteOFF;
        exit;
     end;
     ErreurLabel.caption := '';
     EnregistreBtn.visible := false;
     Screen.Cursor := crHourGlass;
     voieSerie.OnTriggerAvail := VoieSerieTriggerAvail;
     for v := voieCH1 to voieCH2 do if voie[v].active then with voie[v] do begin
        voieCourante := v;
        NbreCourant := 0;
        CaracCourant := 1;
        VoieSerie.OutPut := 'RDWFM'+codeVoie+':'+
           #0 + #0 + #0 + #8+crCR+crLF;
        InstantDebut := time;
        repeat
              if ((NbreCourant-gauge.progress)>32) then
                         gauge.progress := NbreCourant;
              Application.processMessages;
        until (NbreCourant>=NbrePointsMemoire) or
              (DureeEcoulee(InstantDebut)>TimeOutLecture);
        if (NbreCourant>=NbrePointsMemoire)
          then begin
             gauge.progress := NbrePointsMemoire;
             AcqFaite := true;
          end
          else begin
             gauge.progress := 0;
             voie[v].active := false;
          end
     end;
     Screen.Cursor := crDefault;
     SetBoutonAcq;
     Screen.Cursor := crDefault;
     if AppelRegressi then begin
        FormDDE.EnvoieDonnees(true);
        AppelRegressi := false;
     end;
     remoteOff;
end;

procedure THamegMain.FormClose(Sender: TObject;var Action: TCloseAction);
var v : indiceVoie;
    INI : Tinifile;
    i : integer;
begin
     if voieSerie.open and
        (voieSerie.tracing=tlOn) then
            voieSerie.tracing := tlDump;
     if voieSerie.open and
        (voieSerie.logging=tlOn) then
            voieSerie.logging := tlDump;
     if testEnCours then
        testEnCours := MessageDlg('Acquisition correcte ?',mtConfirmation,[mbYes,mbNo],0)=mrYes;
     if testEnCours then ListeCode.add(identiteScope);
     for v := voieCH1 to voieCH2 do voie[v].free;
     try
     Ini := TiniFile.Create(RegHM407);
     Ini.WriteInteger('COM','NUM',voieSerie.ComNumber);
     Ini.WriteInteger('COM','Vitesse',codeVitesse);
     Ini.WriteInteger('Code','Count',ListeCode.count);
     for i := 0 to pred(ListeCode.count) do begin
         Ini.writeString('Code',intToStr(i),listeCode[i]);
     end;
     Ini.Free;
     except
     end;
     ListeCode.free;
end;

procedure THamegMain.RegressiItemClick(Sender: TObject);
begin
     FormDDE.Execute(eFOCUS)
end;

procedure THamegMain.RegSaveBtnClick(Sender: TObject);
begin
   if ConstanteDlg.showModal=mrOk then begin
      FormDDE.EnvoieDonnees(true);
      sauvegarde := true;
   end;
end;

procedure THamegMain.ClipSaveBtnClick(Sender: TObject);
begin
     FormDDE.EnvoieDonnees(false);
     sauvegarde := true;
end;

procedure THamegMain.SetBoutonAcq;
begin
     EnregistreBtn.visible := OscilloBranche;
     FileSaveBtn.Visible := AcqFaite;
     ClipSaveBtn.Visible := AcqFaite;
     RegSaveBtn.Visible := AcqFaite;
end;

procedure THamegMain.VerifOscillo;
var i : integer;
begin
     try { voie Srie }
     {$IFDEF DEBUG}
        voieSerie.traceName := 'HM407'+intToStr(voieSerie.comNumber)+'.trc';
        voieSerie.logName := 'HM407'+intToStr(voieSerie.comNumber)+'.log';
        voieSerie.tracing := tlOn;
        voieSerie.logging := tlOn;
     {$ENDIF}
     voieSerie.Open := true;
     AcqFaite := false;
     sauvegarde := false;
     remoteON; { prise de controle et autoconfig de la vitesse }
     IdentiteScope := GetStringCRLF('ID?'); { Identifie the scope hard }
     OscilloBranche := (Pos('HM',IdentiteScope)<>0);
     for i := 0 to pred(ListeCode.count) do
               OscilloBranche := OscilloBranche or
                    (Pos(ListeCode[i],IdentiteScope)<>0);
     TestEnCours := false;
     versionScope := '';
     RemoteOFF;
     if OscilloBranche
        then begin
           OscilloBranche := false;                                   
           for i := 0 to pred(ListeCode.count) do
               OscilloBranche := OscilloBranche or
                    (Pos(ListeCode[i],IdentiteScope)<>0);
           if not OscilloBranche then begin
              OscilloBranche := MessageDlg(IdentiteScope+' = oscillo Hameg ?',mtConfirmation,[mbYes,mbNo],0)=mrYes;
              TestEnCours := oscilloBranche;
           end;
           if oscilloBranche
              then begin
                 // Identifie la version soft 
                  VersionScope := GetStringCRLF('VERS?');
                  Delete(VersionScope,1,5);
                  Delete(IdentiteScope,1,3);
                  IdentiteScope := 'Hameg '+identiteScope;
                  TestEnCours := false;
              end
              else begin
                   ShowMessage('Acquisition impossible');
                   VoieSerie.Open := false;
              end;
        end
        else begin
             IdentiteScope := 'Oscillo Hameg non branch sur '+ComName(VoieSerie.comNumber);
             ShowMessage(IdentiteScope);
             VoieSerie.Open := false;
        end;
     SetBoutonAcq;
     Caption := identiteScope;
     ErreurLabel.caption := '';
     except
         on E : EAPDexception do begin
            VoieSerie.Open := false;
            OscilloBranche := false;
            IdentiteScope := 'Hameg : vrifier la voie srie';
            showMessage(IdentiteScope);
            setBoutonAcq;
         end;
     end;
     {$IFDEF DEBUG}
        voieSerie.tracing := tlDump;
        voieSerie.logging := tlDump;
     {$ENDIF}
end;

procedure THamegMain.SetOscilloClick(Sender: TObject);
begin with ComCfgDlg do begin
     Numero := voieSerie.ComNumber;
     VitesseComRG.itemIndex := CodeVitesse;
     if ShowModal=mrOK then begin
        voieSerie.ComNumber := Numero;
        codeVitesse := VitesseComRG.itemIndex;
        voieSerie.baud := vitesseBaud[codeVitesse];
     end;
     VerifOscillo;
end end;

procedure THamegMain.FormActivate(Sender: TObject);
begin
     if not OscilloBranche then VerifOscillo;
     if not OscilloBranche then SetOscilloClick(sender);
end;

Function THamegMain.GetStringCount(const Commande : ansiString;count : integer) : ansiString;
var ET : eventTimer;
begin
    voieSerie.FlushOutBuffer;
    voieSerie.FlushInBuffer;
    voieSerie.OnTriggerAvail := VoieSerieTriggerReponse;
    ChaineBin := '';
    VoieSerie.OutPut := Commande+crCR+crLF;
    newTimer(ET,18);
    repeat application.processMessages
    until (length(chaineBin)>count) or timerExpired(ET);
    result := chaineBin;
    voieSerie.OnTriggerAvail := VoieSerieTriggerAvail;
end;

procedure THamegMain.VoieSerieTriggerAvail(CP: TObject; Count: Word);
var i : integer;
    valeurInt : byte;
begin
   for i := 1 to count do begin
      valeurInt := ord(VoieSerie.GetChar);
      inc(CaracCourant);
      if (CaracCourant>12) and
         oscilloBranche and
         (voieCourante<>0) and
         (NbreCourant<NbrePointsMemoire) then begin
            voie[voieCourante].valeur[NbreCourant] := valeurInt;
            inc(NbreCourant);
      end;
   end;
end;

procedure THamegMain.VoieSerieTriggerReponse(CP: TObject; Count: Word);
var i : integer;
begin
   for i := 1 to count do
       chaineBin := chaineBin+VoieSerie.GetChar
end;

procedure THamegMain.NomEditChange(Sender: TObject);
var num : byte;
begin
     num := (sender as Tcomponent).tag;
     if num=1 then Voie[voieCH1].nom := Nom1Edit.text;
     if num=2 then Voie[voieCH2].nom := Nom2Edit.text;
end;

procedure THamegMain.RegNewFileItemClick(Sender: TObject);
begin
      FormDDE.EnvoieDonnees(true)
end;

procedure THamegMain.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin
     with Msg.MinMaxInfo^ do begin
          ptMinTrackSize := point(340,300);
          ptMaxTrackSize := point(640,300);
     end;
end;

procedure THamegmain.WMAcqReg(var Msg : TMessage);
begin
    AppelRegressi := true;
    EnregistreBtnClick(nil);
end;

procedure THamegmain.RemoteON;
var reponse : ansiString;
begin
   reponse := GetStringCRLF(' ');
   AfficheErreur(reponse);
end;

procedure THamegmain.RemoteOFF;
var reponse : ansiString;
begin
   reponse := GetStringCRLF('RM0');
   AfficheErreur(reponse);
   voieCourante := 0;
end;

procedure THamegMain.SignifEditChange(Sender: TObject);
var v : integer;
begin
     v := (sender as Tcomponent).tag;
     Voie[v].signif := (sender as Tedit).text;
end;

Procedure THamegMain.AfficheErreur(R : String);
const
     Pb : array[0..6] of string =
       ('Pas de rponse de l''oscillo','Syntax error !',
         'Data error !','Buffer overflow !',
         'Bad data set !','Adjust error !','Timing error !');
var code : integer;
begin
   if length(R)=0
      then code := 0
      else code := ord(R[1])-ord('0');
   if (code>=0) and (code<7) then ErreurLabel.caption := Pb[code];
end;

Function THamegMain.GetStringCRLF(const commande : ansiString) : ansiString;
var Timer : EventTimer;
    C : ansichar;
    sauveTrigger : TTriggerAvailEvent;
    compteur : integer;
    chaineWait : ansiString;
begin
    SauveTrigger := VoieSerie.onTriggerAvail;
    VoieSerie.onTriggerAvail := nil;
    voieSerie.FlushOutBuffer;
    voieSerie.FlushInBuffer;
    chaineWait := '';
    VoieSerie.OutPut := Commande+crCR+crLF;
    newTimer(timer,18); { 1 seconde }
    compteur := 0;
    repeat     
        if voieSerie.charReady
           then begin
              C := voieSerie.GetChar;
              if C>=' '
                 then ChaineWait := chaineWait+C
                 else if (c=crCR) or (c=crLF) then inc(compteur);
           end
           else Application.processMessages;
    until (compteur=2) or timerExpired(timer);
    VoieSerie.onTriggerAvail := sauveTrigger;
    if compteur=2
       then result := chaineWait
       else result := '';
end;

end.


