unit Hmain;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ADport, sysUtils, Messages,
  clipBrd, spin, adexcept, inifiles, ooMisc,
  jmmUtil, hmdef, Gauges, hmconst, hmcom, XPMan;

const
     WM_Acq_Reg = WM_USER + 0;

type
  THamegMain = class(TForm)
    SaveDialogData: TSaveDialog;
    PanelAide: TPanel;
    VoieSerie: TApdComPort;
    BoutonsPanel: TPanel;
    FileSaveBtn: TSpeedButton;
    ClipSaveBtn: TSpeedButton;
    RegSaveBtn: TSpeedButton;
    EnregistreBtn: TSpeedButton;
    SetBtn: TSpeedButton;
    GroupBoxTemps: TGroupBox;
    GroupBoxCH1: TGroupBox;
    GammeCH1: TScrollBar;
    GammeEditCH1: TEdit;
    BaseDeTempsEdit: TEdit;
    BaseDeTempsScroll: TScrollBar;
    GroupBoxCH2: TGroupBox;
    GammeCH2: TScrollBar;
    GammeEditCH2: TEdit;
    Nom1Edit: TEdit;
    Nom2Edit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    ZeroGB: TGroupBox;
    GaugeZero: TGauge;
    CloseBtn: TSpeedButton;
    AideBtn: TSpeedButton;
    GroupBox1: TGroupBox;
    GaugeData: TGauge;
    Panel1: TPanel;
    Memo1: TMemo;
    XPManifest1: TXPManifest;
    procedure ShowHint(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure SaveItemClick(Sender: TObject);
    procedure AboutItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RegressiItemClick(Sender: TObject);
    procedure RegSaveBtnClick(Sender: TObject);
    procedure ClipSaveBtnClick(Sender: TObject);
    procedure SetOscilloClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure VoieSerieTriggerAvail(CP: TObject; Count: Word);
    procedure BaseDeTempsScrollChange(Sender: TObject);
    procedure GammeScrollChange(Sender: TObject);
    procedure NomEditChange(Sender: TObject);
    procedure RegNewFileItemClick(Sender: TObject);
  private
    IdentiteScope : ansiString;
    Ncourant : integer;
    AcqFaite,OscilloBranche : boolean;
    LectureZero,ZeroFait : boolean;
    AppelRegressi : boolean;
    isHM408,zoomLog : boolean;
    finMsg : ansiString;
    RegHM305 : string;
    grecActif : boolean;
    Procedure SetBoutonAcq;
    Procedure VerifOscillo;
    Function GetString(const Commande : ansiString) : ansiString;
    Procedure MajCalibre;
  public
      voie : array[indiceVoie] of TvoieHameg;
      voieFin : indiceVoie;
      zoomAna10 : boolean;
      procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
  protected
     procedure WMAcqReg(var Msg : TMessage); message WM_Acq_Reg;
  end;

var
  HamegMain: THamegMain;

implementation

uses hmAbout, hmDDE;

{$R *.DFM}

procedure THamegMain.ShowHint(Sender: TObject);
begin
    PanelAide.Caption := Application.Hint
end;

procedure THamegMain.AppMessage(var Msg: TMsg; var Handled: Boolean);
const
         GrecMaj : array[0..25] of char =
  (alphaMaj,BetaMaj,chiMaj,deltaMaj,EpsilonMaj,phiMaj,gammaMaj,etaMaj,iotaMaj,
   psiMaj,kappaMaj,lambdaMaj,MuMaj,NuMaj,omicronMaj,piMaj,thetaMaj,RhoMaj,
   sigmaMaj,tauMaj,upsilonMaj,'V',omegaMaj,xiMaj,'Y',zetaMaj);

        GrecMin : array[0..25] of char =
  (alpha,beta,chi,delta,epsilon,phi,gamma,eta,iota,psi,kappa,lambda,
   mu,nu,omicron,piMin,theta,rho,sigma,tau,upsilon,'v',omega,xi,'y',zeta);

var codeCarac : integer;
begin with Msg do
     case Message of
          wm_char : if (Wparam=7) and (GetKeyState(vk_control)<0)  // Ctrl+G
            then GrecActif := true
            else if grecActif then begin
                 CodeCarac := Wparam-ord('A');
                 if (CodeCarac<26) and (codeCarac>=0)
                    then Wparam := ord(GrecMaj[CodeCarac])
                    else begin
                        CodeCarac := Wparam-ord('a');
                        if (CodeCarac<26) and (codeCarac>=0) then Wparam := ord(GrecMin[codeCarac]);
                    end;
                 grecActif := false;
            end;
    end;
end;

procedure THamegMain.ExitItemClick(Sender: TObject);
begin
  if AcqFaite and
     (MessageDlg('Sauvegarde',mtConfirmation,[mbYes,mbNo],0)=idYes)
     then SaveItemClick(sender);
  Close;
end;

procedure THamegMain.SaveItemClick(Sender: TObject);
var fichier : textFile;
    formatRW3 : boolean;

Procedure EcritPage;
var j,jmax : indiceVecteur;
    v : indiceVoie;
begin
   writeln(fichier,symbReg,1,' PAGE COMMENT');
   writeln(fichier,'');
   jmax := pred(NbrePointsReg);
   if isHM408 and zoomAna10 then jmax := NbrePointsReg div 10;
   writeln(fichier,symbReg2,succ(jmax),' VALEUR VAR');
   for j := 0 to jmax do begin
      	write(fichier,FloatToStrReg(j*deltat),crTab);
        for v := voie1 to voieFin do with voie[v] do
            write(fichier,chaineVolt(j),crTab);
        writeln(fichier);
   end;
end; {ecritPage}

Procedure EcritData;
var j : indiceVecteur;
    v : indiceVoie;
begin
   for j := 0 to pred(NbrePointsReg) do begin
      	write(fichier,FloatToStrWin(j*deltat),crTab);
        for v := voie1 to voieFin do with voie[v] do
    	      write(fichier,chaineVolt(j),crTab);
        writeln(fichier);
   end;
end; {ecritData}

Procedure ecritEnTete;
var v : indiceVoie;
begin if formatRW3
then begin
   writeln(fichier,'EVARISTE REGRESSI WINDOWS 1.0');
   writeln(fichier,symbReg,IntToStr(voieFin+1)+' NOM VAR');
   writeln(fichier,'t');
   for v := voie1 to voieFin do
      writeln(fichier,voie[v].nom);
   writeln(fichier,symbReg,IntToStr(voieFin+1)+' UNITE VAR');
   writeln(fichier,'s');
   writeln(fichier,'V');
   if voieFin=voie2 then writeln(fichier,'V');
   writeln(fichier,symbReg,IntToStr(voieFin+1)+' SIGNIF VAR');
   writeln(fichier,'temps');
   for v := voie1 to voieFin do
      writeln(fichier,voie[v].signif);
   writeln(fichier,symbReg,'1 ACQUISITION');
   writeln(fichier,Application.ExeName)
end
else begin
   writeln(fichier,'Hameg');
   write(fichier,'t',crTab);
   for v := voie1 to voieFin do
      write(fichier,voie[v].nom,crTab);
   writeln(fichier);
   write(fichier,'s'+crTab+'V'+crTab);
   if voieFin=voie1
      then writeln(fichier)
      else writeln(fichier,'V'+crTab);
   write(fichier,'temps',crTab);
   for v := voie1 to voieFin do
       write(fichier,voie[v].signif+crTab);
   writeln(fichier);
end
end; { ecritEnTete }

begin
    if SaveDialogData.Execute then begin
       MajCalibre;
       FormatRW3 := upperCase(ExtractFileExt(SaveDialogData.FileName))='.RW3';
       AssignFile(fichier,SaveDialogData.FileName);
       Rewrite(fichier);
       ecritEnTete;
       if formatRW3 then ecritPage else ecritData;
       CloseFile(fichier);
    end;
end;

procedure THamegMain.AboutItemClick(Sender: TObject);
begin
    AboutBox.ShowModal
end;

procedure THamegMain.FormCreate(Sender: TObject);
var INI : Tinifile;
begin
  Application.OnHint := ShowHint;
  Application.OnMessage := AppMessage;
  voie[voie1] := TvoieHameg.create(false);
  voie[voie2] := TvoieHameg.create(true);
  OscilloBranche := false;
  AppelRegressi := false;
  Ncourant := 0;
  GaugeData.MaxValue := NbrePointsMemoire;
  GaugeZero.MaxValue := NbrePointsMemoire;
  BaseDeTempsScroll.position := BaseDeTempsDefaut;
  GammeCH1.position := CalibreDefaut;
  GammeCH2.position := CalibreDefaut;
  voieFin := voie2;
  reghm305 := appDataDir+'hm305.ini';
  Ini := TiniFile.Create(RegHM305);
  voieSerie.ComNumber := Ini.ReadInteger('COM','Number',1);
  Ini.Free;
end;

procedure THamegMain.EnregistreBtnClick(Sender: TObject);

Function ModeAnalogique : boolean;
var j : integer;
begin
    if isHM408
       then result := valeur[0]=0
       else begin
          ModeAnalogique := false;
          for j := 0 to pred(NbrePointsMemoire div 4) do
                if valeur[j]<>$FF then exit;
          ModeAnalogique := true;
       end;
end;

{ Parameter block (256 Bytes, Addresses: 00-FF)

ADDRESS Parameter
(Addresses in HEX representation, parameters in HEX, ASCII representation resp.)
(not active: 00, otherwise as indicated)

0000    DIGITAL (01), ANALOG (00)
0001    XY mode (01)
0002    DUAL (01), MONO (00)
0003    CH1 (01), CH2 (00)
0004    ROLL (01)
0005    DOT JOIN (01)
0006    SINGLE (01)
0007	  ADD CH1+CH2
0008    x10 mode (magnifier) (01)
0009    RECORD IN PROGRESS (01)
000A    IDENTITY CODE (FD)
000B    READ OUT (01)
000C    not used
000D    EXPAND AKTIVE (01)
000E    not used
000F    not used

0010  CH1=50mV - - - - - -- ; CH1 DATA (examples!)
0020	CH2=20mV - - - - - -- ; CH2 DATA
0030	TB=0.5us - - - - - -- ; TIMEBASE
0040	TL10.83mV - - - - - - ; TRIGGER LEVEL
0050	PT100% - - - - - - -- ; PRE TRIGGER
0060	dt123.08ms - - - - - ; DELTA VALUE
0070	+ - - - - - - - - - - ; PLUS ADD
0080	- - - - - - - - - - - ; RESERVED /
0090	- - - - - - - - - - - ;     "    /
00A0	- - - - - - - - - - - ;     "    / SAVE
00B0	- - - - - - - - - - - ;     "    /
00C0	- - - - - - - - - - - ;     "    /
00D0	CURSOR 00:OFF, 01:TIME, 02:FREQUENCY, 03:VOLTAGE
00D1    not used
00D2	HCURS1YP   HORIZONTALCURSOR 1 Y POSITION  : 1 Byte
00D3	HCURS2YP                    2 Y           : 1 Byte
00D4	HCURS1XP                    1 X 	        : 2 Bytes
00D6	HCURS2XP                    2 X           : 2 Bytes
00D8	VCURS1YP   VERTICALCURSOR   1 Y POSITION  : 1 Byte
00D9	VCURS2YP                    2 Y           : 1 Byte
00DA	VCURS1XP                    1 X           : 2 Bytes
00DC	VCURS2XP                    2 X           : 2 Bytes

X POSITIONS: 0-4000 IN MONO MODE (binary, lower byte first, f.ex. D6)
		     0-2000 IM DUAL MODE (binary, lower byte first)
Y POSITIONS: 00 ... FF (binary)

00DE  not used
00DF  not used
00E0  HAMEG  HM408(- X) (S 3)
00F0	COMMENTS

DUAL MODE: 2 x 2 kBytes of Data (00 ... FF), Adr. Ch 1: 0000 ... 07FF
					     Adr. CH 2: 0800 ... 0FFF
MONO MODE: 1 x 4 kBytes of Data (00 ... FF), Adr.:      0000 ... 0FFF
(Binary values, without any interruption or formatting starting with 0000H,
ending with 0FFFH; take care of address offset for the parameter block (100H)
}

procedure extraitCalibre;
var param : ansiString;
    i : integer;

Function ExtraitString(const titre : ansiString) : String;
var j,debut : byte;
begin
     result := '';
     debut := pos(titre,param);
     if debut<=0 then exit; { donnes incorrectes }
     debut := debut+length(titre);
     j := debut;
     while (length(param)>j) and (param[succ(j)] in chiffreEtcHameg)
        do begin
           inc(j);
           if param[j]='u' then param[j] := ''
        end;
     result := copy(param,debut,j-debut+1);
end;

Function ExtraitFloat(const titre : ansiString) : double;
var tampon : String;
begin
     tampon := extraitString(titre);
     try
     extraitFloat := StrToFloat(tampon);
     except
          extraitFloat := 0;
     end;
end;

Function ExtraitInt(const titre : ansiString) : integer;
var tampon : String;
begin
     tampon := extraitString(titre);
     try
     extraitInt := StrToInt(tampon);
     except
          extraitInt := 0
     end;
end;

var strCalibre : string;
begin
    if valeur[2]=1 then voieFin := voie2 else voieFin := voie1;
    if valeur[9]=1 then showMessage('Appuyez sur le bouton HOLD et recommencez');
    zoomAna10 := valeur[8]=1;
    zoomLog := valeur[13]=1; { expand active E0  E3 }
    for i := 1 to 255 do param[i] := ansichar(valeur[i]);
    StrCalibre := extraitString('CH1=');
    if strCalibre<>''
       then voie[voie1].calibre := strToFloatWin(strCalibre)
       else strCalibre := '1';
    GammeEditCH1.text := strCalibre+'V/div';
    StrCalibre := extraitString('CH2=');
    if strCalibre<>''
       then voie[voie2].calibre := strToFloatWin(strCalibre)
       else strCalibre := '1';
    GammeEditCH2.text := strCalibre+'V/div';
    StrCalibre := extraitString('dU1 ');
    if strCalibre<>'' then deltaV1 := strToFloatWin(strCalibre);
    StrCalibre := extraitString('dU2 ');
    if strCalibre<>'' then deltaV2 := strToFloatWin(strCalibre);
    StrCalibre := extraitString('TB=');
    for i := 0 to 3 do
        if StrCalibre='' then StrCalibre := extraitString('E'+intToStr(i)+'=');
    if strCalibre<>''
       then begin
          BaseDeTempsEdit.text := strCalibre+'s/div';
          deltat := strToFloatWin(strCalibre)*10/NbrePointsBaseDeTemps;
       end
       else begin
          BaseDeTempsEdit.text := '1ms/div';
          deltat := 1e-3*10/NbrePointsBaseDeTemps;          
       end;
end;

var InstantDebut : TdateTime;
    j : indiceVecteur;
label fin;
begin
     if AcqFaite and not OK('Perte des donnes courantes') then exit;
     AcqFaite := false;
     ZeroFait := false;
     EnregistreBtn.visible := false;
     Screen.Cursor := crHourGlass;
     GaugeData.progress := 0;
     GaugeZero.progress := 0;
     Ncourant := 0;
     zoomAna10 := false;
     PanelAide.caption := 'La lecture prend quatre secondes';
     LectureZero := false;
     VoieSerie.OutPut := 'DIG'+finmsg;{ DIG = DIGitize }
     InstantDebut := time;
     repeat
              if ((Ncourant-gaugeData.progress)>32) then
                         gaugeData.progress := Ncourant;
              Application.processMessages;
     until AcqFaite or (DureeEcoulee(InstantDebut)>TimeOutLecture);
     fin : Screen.Cursor := crDefault;
     if AcqFaite
        then VoieFin := voie2
        else begin
             AcqFaite := Ncourant>=(NbrePointsMemoire div 2);
             if AcqFaite then VoieFin := voie1;
        end;
     if AcqFaite
        then gaugeData.progress := gaugeData.maxValue
        else gaugeData.progress := 0;
     if AcqFaite and isHM408 then extraitCalibre;
     if AcqFaite then begin
           if ModeAnalogique then begin
              AcqFaite := false;
              ShowMessage('Appuyer sur le bouton STOR.');
              goto fin;
           end;
           if MessageDlg('Mettre les voies  GD, faire une acquisition'+#13+'Si "Annuler" zro au centre',
              mtInformation,[mbOK,mbCancel],0)=idOK then begin
                LectureZero := true;
                Ncourant := 0;
                Screen.Cursor := crHourGlass;
                VoieSerie.OutPut := 'DIG'+finmsg;{ DIG = DIGitize }
                InstantDebut := time;
                repeat
                    if ((Ncourant-gaugeZero.progress)>32) then
                          gaugeZero.progress := Ncourant;
                    Application.processMessages;
                until ZeroFait or (DureeEcoulee(InstantDebut)>TimeOutLecture);
                if zeroFait and isHM408 and (valeurZero[9]=1) then zeroFait := false;
           end;
           if not zeroFait then
              for j:=0 to NbrePointsTotal do valeurZero[j] := 127;
           gaugeZero.progress := gaugeZero.maxValue;
     end;
     zoomAna10 := isHM408 and zoomAna10;     
     SetBoutonAcq;
     Screen.Cursor := crDefault;
     PanelAide.caption := '';
     if AppelRegressi then begin
        FormDDE.EnvoieDonnees(true);
        AppelRegressi := false;
     end;
end;

procedure THamegMain.FormClose(Sender: TObject;var Action: TCloseAction);
var v : indiceVoie;
    INI : TIniFile;
begin
     for v := voie1 to voie2 do voie[v].free;
     try
     Ini := TiniFile.Create(RegHM305);
     Ini.WriteInteger('COM','Number',voieSerie.ComNumber);
     Ini.Free;
     except
     end;
{$IFDEF trace}
     voieSerie.tracing := tlDump;
     voieSerie.logging := tlDump;
{$ENDIF}
end;

procedure THamegMain.RegressiItemClick(Sender: TObject);
begin
     FormDDE.Execute(eFOCUS)
end;

procedure THamegMain.RegSaveBtnClick(Sender: TObject);
begin
   if ConstanteDlg.showModal=mrOk then begin
      MajCalibre;
      FormDDE.EnvoieDonnees(true);
   end;
end;

procedure THamegMain.ClipSaveBtnClick(Sender: TObject);
begin
     MajCalibre;
     FormDDE.EnvoieDonnees(false)
end;

procedure THamegMain.SetBoutonAcq;
begin
     EnregistreBtn.visible := OscilloBranche;
     FileSaveBtn.Visible := AcqFaite;
     ClipSaveBtn.Visible := AcqFaite;
     RegSaveBtn.Visible := AcqFaite;
     BaseDeTempsScroll.visible := not isHM408;
     GammeCH1.visible := not isHM408;
     GammeCH2.visible := not isHM408;
     ZeroGB.visible := true;
end;

procedure THamegMain.VerifOscillo;
var v : indiceVoie;
begin
     try { voie Srie }
     voieSerie.Open := true;
{$IFDEF trace}
     voieSerie.tracing := tlOn;
     voieSerie.logging := tlOn;
{$ENDIF}
     AcqFaite := false;
     IdentiteScope := GetString('ID?'); { Identifie the scope }
     OscilloBranche := (Pos('HM',IdentiteScope)<>0);
     if OscilloBranche
        then begin
            isHM408 := (Pos('408',IdentiteScope)<>0);
            Caption := 'Lecture oscillo Hameg : '+identiteScope;
            if isHM408 then finmsg := crCR else finmsg := crCR+crLF;
            if isHM408 then begin
               for v := voie1 to voie2 do with voie[v] do
                  decalage := decalage + sizeParamHM408;
               GaugeData.MaxValue := NbrePointsHM408;
               GaugeZero.MaxValue := NbrePointsHM408;
            end;
        end
        else begin
             Caption := 'Oscillo non branch sur '+ComName(VoieSerie.comNumber);
             ShowMessage(Caption);
             VoieSerie.Open := false;
        end;
     except
         on E : EAPDexception do begin
            VoieSerie.Open := false;
            OscilloBranche := false;
            showMessage('Problme voie srie');
         end;
     end;
     SetBoutonAcq;
end;

procedure THamegMain.SetOscilloClick(Sender: TObject);
begin with ComCfgDlg do begin
     Numero := voieSerie.ComNumber;
     if ShowModal=mrOK then
        voieSerie.ComNumber := Numero;
     VerifOscillo;
end end;

procedure THamegMain.FormActivate(Sender: TObject);
begin
     if not OscilloBranche then VerifOscillo;
     if not OscilloBranche then SetOscilloClick(sender);
end;

Function THamegMain.GetString(const Commande : ansiString) : ansiString;
var Timer : EventTimer;
    C : ansichar;
    compteur : integer;
begin
    VoieSerie.onTriggerAvail := nil;
    voieSerie.FlushOutBuffer;
    voieSerie.FlushInBuffer;
    VoieSerie.OutPut := Commande+crCR+crLF;
    result := '';
    newTimer(timer,18); // 18 ticks soit 1 seconde 
    compteur := 0;
    repeat
        if voieSerie.charReady
           then begin
              C := voieSerie.GetChar;
              if C>=' '
                 then result := result+C
                 else if (c=crCR) or (c=crLF) then inc(compteur);
           end
           else voieSerie.processCommunications;
    until (compteur=2) or timerExpired(timer);
    VoieSerie.onTriggerAvail := VoieSerieTriggerAvail;
end;

procedure THamegMain.VoieSerieTriggerAvail(CP: TObject; Count: Word);
var i : integer;
    valeurInt : byte;
begin
   for i := 1 to count do begin
      try
      valeurInt := ord(VoieSerie.GetChar);
      if oscilloBranche then if lectureZero
            then begin
               if not ZeroFait then begin
                  valeurZero[Ncourant] := valeurInt;
                  inc(Ncourant);
                  if isHM408
                     then ZeroFait := Ncourant>=NbrePointsHM408
                     else ZeroFait := Ncourant>=NbrePointsMemoire;
               end;
            end
            else begin
               if not AcqFaite then begin
                  valeur[Ncourant] := valeurInt;
                  inc(Ncourant);
                  if isHM408
                     then AcqFaite := Ncourant>=NbrePointsHM408
                     else AcqFaite := Ncourant>=NbrePointsMemoire
               end;
            end;
      except
      end;
   end;
end;

procedure THamegMain.BaseDeTempsScrollChange(Sender: TObject);
begin
     MajCalibre
end;

procedure THamegMain.GammeScrollChange(Sender: TObject);
begin
     MajCalibre
end;

procedure THamegMain.NomEditChange(Sender: TObject);
var num : byte;
begin
     num := (sender as Tcomponent).tag;
     if num=1 then Voie[voie1].nom := Nom1Edit.text;
     if num=2 then Voie[voie2].nom := Nom2Edit.text;
     MajCalibre;
end;

procedure THamegMain.MajCalibre;
begin
     if isHM408 then exit;
     deltat := duree[BaseDeTempsScroll.position]*10.0/NbrePointsBaseDeTemps;
     BaseDeTempsEdit.text := nomBaseDeTemps[BaseDeTempsScroll.position]+'s/div';
     voie[voie1].calibre := gamme[GammeCH1.position];
     voie[voie2].calibre := gamme[GammeCH2.position];
     GammeEditCH1.text := nomCalibre[GammeCH1.position]+'V/div';
     GammeEditCH2.text := nomCalibre[GammeCH2.position]+'V/div';
end;

procedure THamegMain.RegNewFileItemClick(Sender: TObject);
begin
      MajCalibre;
      FormDDE.EnvoieDonnees(true)
end;

procedure THamegmain.WMAcqReg(var Msg : TMessage);
begin
    AppelRegressi := true;
    EnregistreBtnClick(nil);
end;

end.


