unit Hmdde;
{ Regressi Client pour recevoir les donnes de l'acquisition }

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DdeMan, ExtCtrls, FileCtrl, registry,
  Hmain, hmDef, jmmUtil, hmconst, ComCtrls, clipbrd, shellApi, math;

type
  Tenvoi = (eAdd,eLoad,ePlus,eAddCol,eFocus);
  TFormDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    procedure FormCreate(Sender: TObject);
    procedure ExecuteMacro(Sender: TObject; Msg: TStrings);
  private
    procedure AjouteConst(var donnees : tstringList);
    function GetFnName(const BufStr: String): String;
    function GetArgs(const BufStr: String): String;
  public
      procedure Execute(Ordre : Tenvoi);
      procedure EnvoieDonnees(DDE : boolean);
  end;

var
  FormDDE: TFormDDE;

implementation

{$R *.DFM}

procedure TFormDDE.Execute(Ordre : Tenvoi);


Procedure lanceRegressi;
var hSemaphore : integer;
begin
   hSemaphore := CreateSemaphore(nil,0,1,'Regressi');
   if (hSemaphore<>0) and
      (GetLastError = Error_Already_Exists) then exit;
   if ShellExecute(0, 'open', Pchar(ClientDde.ServiceApplication), nil, nil, SW_SHOWDEFAULT) >= 32 then sleep(2000);
end;

procedure Lance;
begin
    case ordre of
         eAdd : if not ClientDDE.ExecuteMacro('CLIP|ADD', false) then
            ShowMessage('Transfert non excut');
         eLoad : if not ClientDDE.ExecuteMacro('CLIP|LOAD', false) then
            ShowMessage('Transfert non excut');
         ePlus : if not ClientDDE.ExecuteMacro('CLIP|PLUS', false) then
            ShowMessage('Transfert non excut');
         eAddCol : if not ClientDDE.ExecuteMacro('CLIP|ADDCOL', false) then
            ShowMessage('Transfert non excut');
         eFocus : if not ClientDDE.ExecuteMacro('FOCUS', false) then
            ShowMessage('Transfert non excut');
    end;
    ClientDDE.CloseLink;
end;


begin
     LanceRegressi;
     ClientDDE.SetLink('Regressi','ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
        then lance
        else begin
            sleep(1000);
                    // OpenLik false efface 
            ClientDDE.SetLink('Regressi','ServeurDDE');
            ClientItem.DDEItem := 'ServeurItem';
            if ClientDDE.OpenLink
                then lance
                else ShowMessage('Impossible de lancer Regressi')
        end;
end;

procedure TFormDDE.AjouteConst(var donnees : tstringList);
var valeurConst : extended;
begin with ConstanteDlg do begin
     if (NomConstEdit.text='') then exit;
     ValeurConst := StrToFloatWin(ValeurConstEdit.text);
     if isNan(valeurConst) then exit;
     Donnees.Add('');
     Donnees.Add(NomConstEdit.text);
     Donnees.Add(UniteConstEdit.text);
     Donnees.Add(FloatToStrWin(valeurConst));
end end;

procedure TFormDDE.EnvoieDonnees(DDE : boolean);
var i,imax : indiceVecteur;
    v : indiceVoie;
    ligne : String;
    donnees : tstringList;
begin
     Donnees := tstringList.create;
     Donnees.Add(Application.ExeName);
     if ConstanteDlg.NewPageCB.itemIndex=0
        then Donnees.Add('Acquisition avec oscillo HAMEG')
        else Donnees.Add('');
     Donnees.Add(ConstanteDlg.EditComm.text);
     ligne := 't';
     for v := voie1 to HamegMain.voieFin do with HamegMain.voie[v] do
         ligne := ligne+crTab+nom;
     Donnees.Add(ligne);
     ligne := 's'+crTab+'V';
     if HamegMain.voieFin=voie2 then
         ligne := ligne+crTab+'V';
     Donnees.Add(ligne);
     ligne := 'temps';
     for v := voie1 to HamegMain.voieFin do with HamegMain.voie[v] do
         ligne := ligne+crTab+signif;
     Donnees.Add(ligne);
     imax := pred(NbrePointsReg);
     if HamegMain.zoomAna10 then imax := NbrePointsReg div 10;
     for i := 0 to imax do begin
         ligne := FloatToStrReg(i*deltat);
         for v := voie1 to HamegMain.voieFin do with HamegMain.voie[v] do
             ligne := ligne+crTab+chaineVolt(i);
         Donnees.Add(ligne);
     end;
     AjouteConst(donnees);
     ClipBoard.astext := Donnees.Text;
     if DDE then begin
        if ConstanteDlg.NewPageCB.itemIndex=0
           then Execute(eLOAD)
           else Execute(eADD);
        ConstanteDlg.NewPageCB.itemIndex := 1
     end;
     donnees.free;
end;

procedure TFormDDE.FormCreate(Sender: TObject);
var Ini : TregIniFile;
begin
    Ini := TregIniFile.create('Software\Regressi');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','');
    Ini.Free;
    if ClientDDE.ServiceApplication='' then begin
       Ini := TRegIniFile.create('Software');
       ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','');
       Ini.Free;
    end;
end;

procedure TFormDDE.ExecuteMacro(Sender: TObject; Msg: TStrings);
var Fonction,NomFichier : String;
begin
     if (Msg.Count = 1) then begin
       try
       NomFichier := GetArgs(Msg[0]);
       Fonction := GetFnName(Msg[0]);
       if CompareText('CONFIG|LOAD',Fonction) = 0 then begin
           HamegMain.setFocus;
           exit;
       end;    
       if CompareText('CONFIG|SAVE',Fonction) = 0 then exit;
       if CompareText('FOCUS',Fonction) = 0 then begin
           ConstanteDlg.NewPageCB.itemIndex := 0;
           HamegMain.setFocus;
           exit;
       end;
       if CompareText('GETDATA',Fonction) = 0 then begin
           ConstanteDlg.NewPageCB.itemIndex := 1;
           postMessage(HamegMain.Handle,WM_ACQ_REG,0,0);
           exit;
       end;
       MessageDlg('Fonction inconnue : ' + Msg[0], mtError, [mbOK], 0);
       except
            MessageDlg('Syntaxe Macro DDE : Fonction(Paramtre)', mtError, [mbOK], 0);
       end;
     end
     else MessageDlg('Un message  la fois SVP', mtError, [mbOk], 0);
end;

function TFormDDE.GetArgs(const BufStr: String): String;
var ArgStart, ArgEnd : integer;
begin
  { recherche parenthses ouvrante et fermante : fonction(argument) }
  ArgStart := Pos('(', BufStr);
  ArgEnd := Pos(')', BufStr);
  if (ArgStart >= ArgEnd)
     then result := ''
     else result := Copy(BufStr, Succ(ArgStart), ArgEnd - Succ(ArgStart));
end;

function TFormDDE.GetFnName(const BufStr: String): String;
var OpenBracketPos: integer;
begin
  OpenBracketPos := Pos('(', BufStr);
  if (OpenBracketPos <= 0)
     then result := BufStr
     else result := Copy(BufStr, 1, Pred(OpenBracketPos));
end;

end.
