unit Hmdef;

interface

uses winTypes, winProcs, sysUtils, graphics, classes, printers,
     Forms, Controls, Buttons, StdCtrls, ExtCtrls, Dialogs, jmmUtil;

const
        IntSansSignif = -1;
        NbrePointsReg = 2048;
        sizeParamHM408 = 256;
        NbrePointsMemoire = 4096;
        NbrePointsHM408 = NbrePointsMemoire+sizeParamHM408;
        NbrePointsTotal = 5000;
        NbrePointsUneVoie = 2048;
        NbrePointsBaseDeTemps = 2000;
        voieX = 0;
        voie1 = 1;
        voie2 = 2;
        MaxCalibre = 10;
        CalibreDefaut = 5;
        MaxBaseDeTemps = 21;
        BaseDeTempsDefaut = 10;
        TimeOutLecture = 8;
         { lecture de 4096 points  9600 bauds = 4 secondes }

type
        indiceVecteur = 0..NbrePointsTotal;
        vecteur = array[indiceVecteur] of integer;
        indiceVoie = voie1..voie2;
        Tcalibre = 1..MaxCalibre;
        TbaseDeTemps = 1..MaxBaseDeTemps;

        TvoieHameg = class
            		calibre : single;
                decalage : integer;
                Nom : string;
                Signif : String;
            		constructor create(isVoie2 : boolean);
                function chaineVolt(j : indiceVecteur) : string;
	end;

const
     nomCalibre : array[Tcalibre] of string[5] =
                ('5','2','1',
                 '500m','200m','100m',
                 '50m','20m','10m',
                 '5m');
     gamme : array[Tcalibre] of real =
                (5.0,2.0,1,0.5,0.2,0.1,0.05,0.02,0.01,0.005);
     nomBaseDeTemps : array[TbaseDeTemps] of string[5] =
             ('5','2','1',
              '500m','200m','100m',
              '50m','20m','10m',
              '5m','2m','1m',
              '500','200','100',
              '50','20','10',
              '5','2','1');
     Duree : array[TbaseDeTemps] of real =
             (5.0,2.0,1.0,
              0.5,0.2,0.1,
              0.05,0.02,0.01,
              5e-3,2e-3,1e-3,
              5e-4,2e-4,1e-4,
              5e-5,2e-5,1e-5,
              5e-6,2e-6,1e-6);

Var deltat,deltaV1,deltaV2 : single;
    valeur,valeurZero : vecteur;
    voieFin : byte;

IMPLEMENTATION

function TvoieHameg.chaineVolt(j : indiceVecteur) : String;
begin
     chaineVolt := FloatToStrF((valeur[j+decalage]-valeurZero[j+decalage])*calibre/25.0,ffGeneral,5,1)
end;

constructor TvoieHameg.Create(isVoie2 : boolean);
begin
        inherited create;
        Signif := 'tension';
        calibre := 1.0;
        decalage := 0;
        Nom :='V1';
        if isVoie2 then begin
            decalage := NbrePointsMemoire div 2;
            Nom :='V2';
        end;
end;{--- TvoieHameg.Create ---}

end. 

